import greenfoot.*;

/**
 * Write a description of class Zombie here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Zombie extends Mover
{
    public int stability = 0;
    
    public Zombie()
    {
        stability = Greenfoot.getRandomNumber(200);
    }
    
    /**
     * Act - do whatever the Zombie wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        zombieWalk();
        gameOver();
    }
    
    // Moving like a zombie at random speeds
    public void zombieWalk()
    {
        move(Greenfoot.getRandomNumber(3)- 3);
    }
    
     /**
     * Return the current stability of this zombie. (If it goes down to 
     * zero, it dies.)
     */
    public int getStability()
    {
        return stability;
    }
       
    /**
     * Hit this zombie dealing the given amount of damage.
     */
    public void hit(int damage) 
    {
        stability = stability - damage;
        if (stability <= 0) 
        {
            death();
        }
    }
    
    //Death of a Zombie
    public void death()
    {
    if(stability < 16)
    {
        getWorld().removeObject(this);
        //When a Zombie is killed increment the Kill Counter by 1
        Soldier.deadZombies = Soldier.deadZombies + 1;
        stability = Greenfoot.getRandomNumber(300);
        return;
    }
    }
    
    //Game Over
    public void gameOver()
    {
        if(isTouching(Soldier.class))
        {
            removeTouching(Soldier.class);
            setImage("GameOver.png");
            Greenfoot.stop();
        }
    }
}
